<template>
	<component
		:is="dataShared.element"
		v-if="dataShared.element === 'nuxt-link'"
		v-bind="dataShared.props"
		:class="$style.button"
		@click.native="click"
	>
		<div :class="$style.buttonInner">
			<div :class="$style.left">
				<svg :class="$style.leftIcon" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 50 20">
					<polygon
						points="37.97 0 37.24 0.9 47.56 9.39 0 9.39 0 10.55 47.43 10.55 37.23 19.11 37.98 20 50 9.91 37.97 0"
					/>
				</svg>
			</div>
			<div :class="$style.right">
				<div :class="$style.text">
					<slot />
				</div>
			</div>
		</div>
	</component>
	<component
		:is="dataShared.element"
		v-else
		v-bind="dataShared.props"
		:class="[$style.button, { [$style.isAddingToCart]: isAddingToCart }]"
		@click="click"
	>
		<div :class="$style.buttonInner">
			<div v-if="isAddingToCart" :class="$style.spinnerWrapper">
				<BaseSpinner />
			</div>
			<div :class="$style.left">
				<svg :class="$style.leftIcon" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 50 20">
					<polygon
						points="37.97 0 37.24 0.9 47.56 9.39 0 9.39 0 10.55 47.43 10.55 37.23 19.11 37.98 20 50 9.91 37.97 0"
					/>
				</svg>
			</div>
			<div :class="$style.right">
				<div :class="$style.text">
					<template v-if="isAddToCart">{{ addToCartText }}</template>
					<slot v-else />
				</div>
			</div>
		</div>
	</component>
</template>

<script>
import smartLinkButton from '~/mixins/smart-link-button';

const ignore = { validator: () => true, default: undefined };

export default {
	mixins: [smartLinkButton],

	props: {
		appearance: ignore,
		forceColor: ignore,
		customAppearance: ignore,
		size: ignore,
	},
};
</script>

<style lang="scss" module>
@import '@design';

.button {
	position: relative;
	display: inline-block;
	font-size: 1.4rem;
	line-height: 2rem;
	color: inherit;
	text-align: center;
	border: 0;
	border-radius: 0;
}

.buttonInner {
	position: relative;
	display: flex;
}

.left {
	flex: 0 0 auto;
	padding-right: size('s');
}

.leftIcon {
	display: block;
	width: 4.3rem;
	height: 2rem;
	fill: currentColor;

	.isAddingToCart & {
		opacity: 0;
	}
}

.right {
	.isAddingToCart & {
		opacity: 0;
	}
}

.spinnerWrapper {
	position: absolute;
	top: 0;
	left: 0;
	display: flex;
	align-items: center;
	justify-content: center;
	width: 100%;
	height: 100%;
}
</style>
